<template>
  <div>
    <card-container>
      <vxe-toolbar>
        <template #buttons>
          <el-button icon="el-icon-plus" type="primary" size="small" @click="isShowAdd = true">新增</el-button>
          <el-button icon="el-icon-search" type="primary" plain size="small" @click="getList">搜索</el-button>
        </template>
      </vxe-toolbar>
      <vxe-table
        ref="table"
        style="margin-top: 10px;"
        :loading="loading"
        keep-source
        :row-config="{ useKey: 'id', isHover: true }"
        :column-config="{ resizable: true }"
        :edit-rules="validRules"
        :edit-config="{ trigger: 'manual', mode: 'row', showStatus: true, autoClear: false, expandALl: true }"
        :tree-config="{ rowField: 'id', parentField: 'pid' }"
        :data="tableData"
      >
        <vxe-column type="seq" width="58" align="center" />
        <vxe-column tree-node field="name" width="170" title="名称" :edit-render="{ name: 'input', attrs: { type: 'text' } }" />
        <vxe-column field="update_children" title="授权人员" min-width="160" :edit-render="{}">
          <template #edit="{ row }">
            <user-picker style="width: 100%;"
                         multiple
                         :value="row.update_children_ids ? row.update_children_ids.split(',').map(i => Number(i)) : []"
                         @input="e => row.update_children_ids = e.toString()"/>
          </template>
        </vxe-column>
        <vxe-column field="myindex" width="180" title="排序" align="center" :edit-render="{ name: 'input', attrs: { type: 'number' } }" />
        <vxe-column field="operate" title="操作" min-width="220">
          <template #default="{ row }">
            <template v-if="isActiveStatus(row)">
              <el-button size="small" type="primary" @click="saveRowEvent(row)">保存</el-button>
              <el-button size="small" type="primary" plain @click="cancelRowEvent(row)">取消</el-button>
            </template>
            <template v-else>
              <el-button size="small" type="success" @click="$refs['AddDocumentMenu'].setPid(row.id),isShowAdd = true">子栏目</el-button>
              <el-button size="small" type="warning" @click="editRowEvent(row)">编辑</el-button>
              <el-button size="small" type="danger" @click="destroyRowEvent(row)">删除</el-button>
            </template>
          </template>
        </vxe-column>
      </vxe-table>
    </card-container>
    <add-document-menu ref="AddDocumentMenu" :list="tableData" :is-show.sync="isShowAdd" @refresh="getList" />
  </div>
</template>

<script>
import { deepCopy } from '@/utils'
import { menuSave, menuIndex, menuDestroy } from '@/api/document'
import UserPicker from "@/components/UserPicker/index.vue";
import AddDocumentMenu from './components/AddDocumentMenu.vue'
export default {
  components: {
    UserPicker,
    AddDocumentMenu
  },
  data() {
    return {
      isShowAdd: false,

      loading: false,
      select: {
        page: 1,
        page_size: 20
      },
      allAlign: null,
      tableData: [],
      validRules: {
        name: [
          { required: true, message: '请输入角色' }
        ]
      },
      form: {
        id: '',
        pid: '',
        name: '',
        myindex: '',
        update_children_ids: ''
      }
    }
  },
  computed: {
    isActiveStatus() {
      return function(row) {
        if (this.$refs['table']) {
          return this.$refs['table'].isEditByRow(row)
        }
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    editRowEvent(row) {
      if (this.$refs['table']) {
        this.$refs['table'].setEditRow(row)
      }
    },
    cancelRowEvent(row) {
      if (this.$refs['table']) {
        this.$refs['table'].clearEdit().then(() => {
          // 还原行数据
          this.$refs['table'].revertData(row)
        })
      }
    },

    async getList() {
      this.loading = true
      try {
        const res = await menuIndex(this.select)
        this.tableData = res
        this.loading = false
        this.$nextTick(() => {
          this.$refs['table'].setAllTreeExpand(true)
        })
      } catch (err) {
        console.error(err)
        this.loading = false
      }
    },

    async saveRowEvent(row) {
      try {
        await this.$confirm('确认保存？', '提示', {
          confirmButtonText: '确认',
          cancelButtonText: '取消'
        })
        await this.$refs['table'].clearEdit()
        const form = deepCopy(this.form)
        for (const key in form) {
          form[key] = row[key]
        }
        if (!form.password) {
          delete form.password
        }
        this.loading = true
        await menuSave(form)
        await this.getList()
        this.loading = false
      } catch (err) {
        this.loading = false
      }
    },
    async destroyRowEvent(row) {
      try {
        await this.$confirm('确认删除？', '提示', {
          confirmButtonText: '确认',
          cancelButtonText: '取消'
        })
        this.loading = true
        if (row.id) {
          await menuDestroy({
            id: row.id
          })
          await this.getList()
        } else {
          console.log(row)
          this.tableData.splice(this.tableData.findIndex(i => i._X_ROW_KEY === row._X_ROW_KEY), 1)
        }
        this.loading = false
      } catch (err) {
        this.loading = false
      }
    }
  }
}
</script>

<style scoped lang="scss">
.total {
  color: #666;
  text-align: right;
  line-height: 3;
}
::v-deep .el-tag + .el-tag {
  margin-left: 4px;
}
</style>
